<?php

class nc_payment_system_rbs extends nc_payment_system
{

    const PROD_URL = 'https://engine.paymentgate.ru/payment/rest/';
    const TEST_URL = 'https://web.rbsuat.com/ab/rest/';

    protected $automatic = TRUE;

    // принимаемые валюты
    protected $accepted_currencies = array('RUB', 'RUR');

    // параметры сайта в платежной системе
    protected $settings = array(
        'userName' => null,
        'password' => null,
        'stage' => 'one-stage',
        'testmode' => 'yes',
        'returnUrl' => null,

        // http://ДОМЕН/netcat/modules/payment/callback.php?paySystem=nc_payment_system_rbs&type=result
        'resultUrl' => null
    );

    // передаваемые параметры
    protected $request_parameters = array(
    );

    // получаемые параметры
    protected $callback_response = array(
        'formUrl' => null,
        'orderNumber' => null
    );

    public function curl_post_data($data, $url)
    {

        $options = array(
            CURLOPT_URL => $url,
            CURLOPT_POST => true,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POSTFIELDS => http_build_query($data),
        );

        $ch = curl_init();
        curl_setopt_array($ch, $options);
        $json = curl_exec($ch);
        if ($json == false) {
            die ('Curl error: ' . curl_error($ch) . '<br>');
        }

        //Преобразуем JSON в ассоциативный массив
        $result = json_decode($json, TRUE);
        curl_close($ch);

        return $result;
    }

    //новая функция для сессии
    public function execute_payment_session($data, $url)
    {
        return $this->curl_post_data($data, $url);

    }

    //1
    public function execute_payment_request(nc_payment_invoice $invoice)
    {

        $amount = $invoice->get_amount("%0.2F");
        $data = array(
            'userName' => $this->settings['userName'],
            'password' => $this->settings['password'],
            'stage' => $this->settings['stage'],
            'testmode' => $this->settings['testmode'],
            'orderNumber' => $invoice->get_id(),
            'amount' => $amount * 100,
            'returnUrl' => $this->settings['resultUrl'],
        );

        $url = ($this->settings['testmode'] == 'yes') ? self::TEST_URL : self::PROD_URL;

        $response = $this->execute_payment_session($data, $url . "register.do");
        if ($response['errorCode'] == 0) {
            header("Location: " . $response['formUrl']);
        } else {
            die($response['errorMessage']);
        }

        exit;
    }

    /**
     * @param nc_payment_invoice $invoice
     * when?????
     */
    public function on_response(nc_payment_invoice $invoice = null)
    {

//        $invoice->set('status', nc_payment_invoice::STATUS_SUCCESS);
//        $invoice->save();
//        $this->on_payment_success($invoice);
//        $succes_url = $this->get_setting('succes_url');
//        header("Location: " . $succes_url . "?order_id=" . $invoice->get_id());

    }

    /**
     *
     */
    public function validate_payment_request_parameters()
    {

    }

    /**
     * @param nc_payment_invoice $invoice
     */
    public function validate_payment_callback_response(nc_payment_invoice $invoice = null)
    {

        $data = array(
            'userName' => $this->settings['userName'],
            'password' => $this->settings['password'],
            'orderId' => $this->get_response_value('orderId'),
        );

        $url = ($this->settings['testmode'] == 'yes') ? self::TEST_URL : self::PROD_URL;
        $response = $this->curl_post_data($data, $url . "getOrderStatusExtended.do");
        $orderStatus = $response['orderStatus'];

        if ($orderStatus != '1' && $orderStatus != '2') {
            $this->add_error("Что-то пошло не так");
            die();
        }

        $invoice = $this->load_invoice($response['orderNumber']);
        $invoice->set('status', nc_payment_invoice::STATUS_SUCCESS);
        $invoice->save();
        $this->on_payment_success($invoice);
        $success_url = $this->get_setting('returnUrl');
        header("Location: ".$success_url);

    }

    public function load_invoice_on_callback()
    {
        return $this->load_invoice($this->get_response_value('orderId'));
    }
}
